#include <stdlib.h>

#define __SQUISH_INITSIZE 256

#define __SQUISH_INIT                                                 \
    if (len == 0)                                                     \
        return 0;                                                     \
    if (*result == NULL || *outlen < __SQUISH_INITSIZE)               \
    {                                                                 \
        *outlen = __SQUISH_INITSIZE;                                  \
        *result = realloc(*result, __SQUISH_INITSIZE * sizeof(char)); \
    }

#define __SQUISH_WRITE                                      \
    if (*outlen < j + 2)                                    \
    {                                                       \
        *outlen *= 2;                                       \
        *result = realloc(*result, *outlen * sizeof(char)); \
    }                                                       \
    (*result)[j++] = count;                                 \
    (*result)[j++] = last;

int compress(const char *data, size_t len, char **result, size_t *outlen)
{
    __SQUISH_INIT;
    char last = data[0];
    unsigned char count = 1;
    size_t j = 0;
    for (size_t i = 1; i < len; ++i)
    {
        char now = data[i];
        if (now != last || count == 255)
        {
            __SQUISH_WRITE;
            last = now;
            count = 1;
        }
        else
        {
            ++count;
        }
    }
    __SQUISH_WRITE;
    *outlen = j;
    *result = realloc(*result, *outlen * sizeof(char));
}

int decompress(const char *data, size_t len, char **result, size_t *outlen)
{
    __SQUISH_INIT;
    size_t j = 0;
    for (size_t i = 0; i < len; i += 2)
    {
        unsigned char len = data[i];
        char ch = data[i + 1];
        while (*outlen - j < len)
        {
            *outlen *= 2;
            *result = realloc(*result, *outlen * sizeof(char));
        }
        for (int k = j; k < j + len; ++k)
        {
            (*result)[k] = ch;
        }
        j += len;
    }
    *outlen = j;
    *result = realloc(*result, *outlen * sizeof(char));
}
